﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Optimization;
using System.IO;

namespace GOA.Department.ANS.Web
{
    public class BundleConfig
    {
        // For more information on Bundling, visit http://go.microsoft.com/fwlink/?LinkId=254725
        public static void RegisterBundles(BundleCollection bundles)
        {
            //scripts
            bundles.Add(new ScriptBundle("~/bundles/bootstrap").Include("~/Scripts/bootstrap.js"));
            bundles.Add(new ScriptBundle("~/bundles/jqueryval").Include("~/Scripts/jquery.unobtrusive*", "~/Scripts/jquery.validate*"));
            bundles.Add(new ScriptBundle("~/bundles/scripts").Include(
                "~/Scripts/modernizr-*",
                "~/Scripts/jquery-{version}.js",
                "~/Scripts/jquery-ui-{version}.js",
                "~/Scripts/infragistics/infragistics.core.js",
                "~/Scripts/infragistics/infragistics.lob.js",
                "~/Scripts/infragistics/infragistics.dv.js",
                "~/Scripts/jquery.cookie.js"
                ).ForceOrdered());

            //styles
            bundles.Add(new StyleBundle("~/bundles/css").Include(
                "~/Content/bootstrap/bootstrap.css",
                "~/Content/infragistics/themes/metro/infragistics.theme.css",
                "~/Content/infragistics/structure/infragistics.css",
                "~/Content/website.css",
                "~/Content/jquery-ui-custom.css"
                ).ForceOrdered());

            //styles for chart (removed bootstrap, added chart)
            bundles.Add(new StyleBundle("~/bundles/csschart").Include(
                "~/Content/infragistics/themes/metro/infragistics.theme.css",
                "~/Content/infragistics/structure/infragistics.css",
                "~/Content/infragistics/structure/modules/infragistics.ui.chart.new.css"
                ).ForceOrdered());

            BundleTable.EnableOptimizations = false;
        }
    }

    internal class AsIsBundleOrderer : IBundleOrderer
    {
        public virtual IEnumerable<FileInfo> OrderFiles(BundleContext context, IEnumerable<FileInfo> files)
        {
            return files;
        }

        public IEnumerable<BundleFile> OrderFiles(BundleContext context, IEnumerable<BundleFile> files)
        {
            return files;
        }
    }

    internal static class BundleExtensions
    {
        public static Bundle ForceOrdered(this Bundle sb)
        {
            sb.Orderer = new AsIsBundleOrderer();
            return sb;
        }
    }
}