﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using GOA.Department.ANS.Web.Model;
using GOA.Department.ANS.Web.Model.BusinessAssociates;
using GOA.Department.ANS.Web.ViewModels;
using GOA.Department.ANS.Web.Model.Interfaces;
using MvcSiteMapProvider;
using Infragistics.Web.Mvc;

namespace GOA.Department.ANS.Web.Controllers
{
    public class BusinessAssociateController : Controller
    {
        
        IAddressRepository _repositoryAddr = null;

        public BusinessAssociateController()
            : this(new AddressRepository())
        {
        }

        public BusinessAssociateController(IAddressRepository repositoryAddr)
        {
            _repositoryAddr = repositoryAddr;
        }


        #region Address
        public ActionResult Addresses()
        {
            var viewModel = new AddressesViewModel();
            viewModel.Addresses = _repositoryAddr.GetAddresses();
            viewModel.AddressPurposes = _repositoryAddr.GetAddressPurposes();

            return View(viewModel);
        }        

        [HttpPost]
        public ActionResult BAAddressSaveData()
        {
            var response = new Dictionary<string, string>();

            if (ModelState.IsValid)
            {
                var ba = new Address();
                GridModel gridModel = new GridModel();
                List<Transaction<Address>> transactions = gridModel.LoadTransactions<Address>(HttpContext.Request.Form["ig_transactions"]);

                //sometimes while editing a record, transaction is 0. happens randomly dont know why???????
                if (transactions.Count > 0)
                {
                    foreach (Transaction<Address> t in transactions)
                    {
                        switch (t.type)
                        {
                            //ADD
                            case "newrow":
                                Tuple<bool, string, int> opResult;
                                ba.BAKey = 55;
                                ba.Purpose = t.row.Purpose;
                                ba.AddressDetails = t.row.AddressDetails;
                                ba.City = t.row.City;
                                ba.Province = t.row.Province;
                                ba.Zipcode = t.row.Zipcode;
                                ba.Country = t.row.Country;
                                ba.Phone = t.row.Phone;
                                ba.Fax = t.row.Fax;
                                ba.Email = t.row.Email;
                                opResult = _repositoryAddr.Add(ba);
                                if (opResult.Item3 > 0)
                                {
                                    t.row.AddressID = opResult.Item3;
                                    t.rowId = t.row.AddressID.ToString();
                                }
                                response.Add(opResult.Item1 ? "Success" : "Fail", opResult.Item2);
                                response.Add("AddressKey", opResult.Item3.ToString());
                                break;

                            //EDIT
                            case "row":
                                Tuple<bool, string> opResult1;
                                ba.AddressID = t.row.AddressID;
                                ba.BAKey = Convert.ToInt32(t.row.BAKey);
                                ba.Purpose = t.row.Purpose;
                                ba.AddressDetails = t.row.AddressDetails;
                                ba.City = t.row.City;
                                ba.Province = t.row.Province;
                                ba.Zipcode = t.row.Zipcode;
                                ba.Country = t.row.Country;
                                ba.Phone = t.row.Phone;
                                ba.Fax = t.row.Fax;
                                ba.Email = t.row.Email;

                                if (ba.Purpose == null)
                                {
                                    response.Add("Fail", "Purpose can't be blank.");
                                    break;
                                }
                                opResult1 = _repositoryAddr.Edit(ba);
                                response.Add(opResult1.Item1 ? "Success" : "Fail", opResult1.Item2);
                                break;
                            
                        }
                    }
                }
                else
                    response.Add("Fail", "There is no change in record.");
            }
            else
                response.Add("Fail", "Form validation Error!");

            JsonResult result = new JsonResult();
            result.Data = response;
            return result;
        }

        #endregion
        


    }
    
}
